import { CommandHandler } from '@nestjs/cqrs';
import { UsernameRepository } from '../../adapters/secondaries/username.repository';
import { AddUsernameCommand } from '../../commands/add-username.command';
import { Username } from '../entities/username';

@CommandHandler(AddUsernameCommand)
export class AddUsernameUseCase {
  constructor(private readonly _usernameRepository: UsernameRepository) {}

  async execute(command: AddUsernameCommand): Promise<Username> {
    const { uuid, username, type } = command.addUsernameRequest;
    try {
      return await this._usernameRepository.create({
        uuid,
        type,
        username,
      });
    } catch (e) {
      throw e;
    }
  }
}
